package com.google.gwt.misge.alarms.client;
/*
 * @author jiorgos |  misge.intra@gmail.com under LGPL Licence and WITHOUT ANY WARRANTY
 */
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.KeyboardListener;
import com.google.gwt.user.client.ui.Widget;

/**
 * A simple example of an 'about' dialog box.
 */
public class AboutDialog extends DialogBox {

  private static final String LOGO_IMAGE = "logo.gif";
  
  private String type = null;
  HorizontalPanel buttonPanel = new HorizontalPanel();
  
  public AboutDialog() {
    // Use this opportunity to set the dialog's caption.
    setText("GWT Alarm actions");

    // Create a DockPanel to contain the 'about' label and the 'OK' button.
    DockPanel outer = new DockPanel();
    outer.setSpacing(4);

    outer.add(new Image(LOGO_IMAGE), DockPanel.WEST);

   
    buttonPanel.setHorizontalAlignment(HorizontalPanel.ALIGN_RIGHT);
    
   
    final AlarmServiceAsync alarmServiceaAsync = GwtAlarmItems.getInstance().getAsync();

    buttonPanel.add(new Button("Acknowledge all", new ClickListener() {
      public void onClick(Widget sender) {
        	if (type != null){
        		alarmServiceaAsync.ackAlarm("*",new AsyncCallback() {
                    public void onFailure(Throwable caught) {
                    	Window.alert("Failed to acknowledge all alarms:");
                    }

                    public void onSuccess(Object result) {                    	
                    	Window.alert("All alarms acknowledged ");                    	
                    }
                });   
        	}
          hide();
        }
      }));
   
    outer.add(buttonPanel, DockPanel.SOUTH);

    HTML text = new HTML("Acknowledge all the Alarms from the selected category or all of them from all the categories");
    text.setStyleName("mail-AboutText");
    outer.add(text, DockPanel.CENTER);
    outer.setSpacing(8);

    setWidget(outer);
  }
  
  
  
  public void setType(final String type,final GWTAlarm[] id){
		this.type = type;
		
	    final AlarmServiceAsync alarmServiceaAsync = GwtAlarmItems.getInstance().getAsync();

		 buttonPanel.add(new Button("Acknowledge all of type:"+type, new ClickListener() {
		        public void onClick(Widget sender) {
		        	if (type != null){
		        		alarmServiceaAsync.ackAlarm(id,new AsyncCallback() {
		                    public void onFailure(Throwable caught) {
		                    	Window.alert("Failed to remove alarm with id:"+id);
		                    }

		                    public void onSuccess(Object result) {
		                    	
		                    	Window.alert("Removed " +id.length +" alarms of type:"+ type);
		                    	
		                    }
		                }); 
		        	  
		        	}
		          hide();
		        }
		      }));
         
         buttonPanel.add(new Button("Close", new ClickListener() {
                public void onClick(Widget sender) {
                  hide();
                }
              }));
	  }
  
  
  public boolean onKeyDownPreview(char key, int modifiers) {
    // Use the popup's key preview hooks to close the dialog when either
    // enter or escape is pressed.
    switch (key) {
      case KeyboardListener.KEY_ENTER:
      case KeyboardListener.KEY_ESCAPE:
        hide();
        break;
    }

    return true;
  }
}
