package com.google.gwt.misge.alarms.client;
/*
 * @author jiorgos |  misge.intra@gmail.com under LGPL Licence and WITHOUT ANY WARRANTY
 */
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.FlexTable;
import com.google.gwt.user.client.ui.FlowPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.HasHorizontalAlignment;
import com.google.gwt.user.client.ui.HasVerticalAlignment;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.MouseListenerAdapter;
import com.google.gwt.user.client.ui.ScrollPanel;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.client.ui.HTMLTable.CellFormatter;
import com.google.gwt.user.client.ui.HTMLTable.RowFormatter;


public class AlarmList extends ScrollPanel  implements ClickListener {

	private static final int VISIBLE_ALARM_COUNT = 10;

	private final static String ACTION = "ack";

	private HTML countLabel = new HTML();
   
	private HTML newerButton = new HTML(
			"<a href='javascript:;'>&lt; newer</a>", true);

	private HTML olderButton = new HTML(
			"<a href='javascript:;'>older &gt;</a>", true);

	private int startIndex, selectedRow = -1;

	private FlexTable table = new FlexTable();
	//private SortableTable table = new SortableTable();
	 
	private HorizontalPanel navBar = new HorizontalPanel();

	private static GWTAlarm tmpalarm[] = null;

	public AlarmList() {
		// Setup the table.
		table.setCellSpacing(0);
		table.setCellPadding(2);
		table.setWidth("100%");

		// Create the 'navigation' bar at the upper-right.
		HorizontalPanel innerNavBar = new HorizontalPanel();
		innerNavBar.setStyleName("tableHeader");
		innerNavBar.setSpacing(8);
		
        innerNavBar.add(newerButton);
		innerNavBar.add(countLabel);
		innerNavBar.add(olderButton);

		navBar.setHorizontalAlignment(HorizontalPanel.ALIGN_RIGHT);
		navBar.add(innerNavBar);
		navBar.setWidth("100%");		 
		setAlwaysShowScrollBars(true);
		 
		
		initTable();
		
		super.setWidget(table);
		super.ensureVisible(table);
		setStyleName("mail-List");

		newerButton.addClickListener(this);
		olderButton.addClickListener(this);
        
	}

	public void onClick(Widget sender) {
		
		if (sender == olderButton) {
			// Move forward a page.
			startIndex += VISIBLE_ALARM_COUNT;
			if (startIndex >= tmpalarm.length){
				startIndex -= VISIBLE_ALARM_COUNT;
			}
			else {
			    selectedRow = -1;
				update(tmpalarm);				
			}
		} else if (sender == newerButton) {
			// Move back a page.
			startIndex -= VISIBLE_ALARM_COUNT;
			if (startIndex < 0)
				startIndex = 0;
			else {
				//styleRow(selectedRow, false);
				selectedRow = -1;
				update(tmpalarm);
			}
		}
	}

	private void initTable() {		    
		    table.setWidth("100%");
		    table.setStyleName("sortableTable");
		    table.setBorderWidth(1);
		    table.setCellPadding(4);
		    table.setCellSpacing(1);
		               
            table.setText(0, 0, "Sender        ");
            table.setText(0, 1, "SequenceNumber        ");
            table.setText(0, 2, "Ack        ");
            table.setText(0, 3, "Extra         ");
            
            table.setWidget(0, 4, navBar);
		    
		    // Set Style Name for the header
			RowFormatter rowFormatter = table.getRowFormatter();
			rowFormatter.setStyleName(0, "tableHeader");
			
			// Set the Styles for the Data Rows and Columns
			CellFormatter cellFormatter = table.getCellFormatter();
			// Set the styles for the headers
			for (int colIndex=0; colIndex<5; colIndex++){
				cellFormatter.setStyleName(0, colIndex, "headerStyle");
				cellFormatter.setAlignment(0, colIndex, HasHorizontalAlignment.ALIGN_CENTER, HasVerticalAlignment.ALIGN_MIDDLE);
			}

			for(int rowIndex=1; rowIndex<VISIBLE_ALARM_COUNT+1; rowIndex++){
				if(rowIndex%2 == 0){
					rowFormatter.setStyleName(rowIndex, "customRowStyle");
				}else{
					rowFormatter.setStyleName(rowIndex, "tableRow");
				}
			}
	}
	
	private void createPopup(final Button link, final int idx,
			final GWTAlarm alarm, final String action) {

		link.addClickListener(new ClickListener() {
			public void onClick(Widget sender) {
				if (action.equals(ACTION)) {
					link.setEnabled(false);
					GwtAlarmItems.getInstance().removeAlarm(alarm);
				} else {
					AboutDialog dlg = new AboutDialog();
					int left = (Window.getClientWidth() - 512) / 2;
					int top = (Window.getClientHeight() - 256) / 2;
					dlg.setPopupPosition(left, top);

					dlg.setType(alarm.severity, tmpalarm);
					dlg.show();
				}
			}
		});
	}

	private void setDescription(final Label link, final GWTAlarm alarm) {

		link.addClickListener(new ClickListener() {
			public void onClick(Widget sender) {
				AlarmsEntryPoint.get().displayItem(alarm);
				link.setStyleName("alarm-SelectedRow");
				 
			}
		});
		
	
		
		link.addMouseListener(new MouseListenerAdapter() {
			public void onMouseLeave(Widget sender) {
				 
				link.removeStyleName("alarm-SelectedRow");
			}
		});
		
	}

	public void update(GWTAlarm alarms[]) {
		tmpalarm = alarms;
		// Show the selected emails.
		int i = 0;


		int count = alarms.length;
	    int max = startIndex + VISIBLE_ALARM_COUNT;
	    if (max > count)
	      max = count;

	    newerButton.setVisible(startIndex != 0);
	    olderButton.setVisible(startIndex + VISIBLE_ALARM_COUNT < count);
	    countLabel.setText("" + (startIndex + 1) + " - " + max + " of " + count);


	    
		if(alarms.length == 0){
			AlarmsEntryPoint.get().displayItem(new GWTAlarm());
			clear(i);
			return;
		}
		
		for (; i < VISIBLE_ALARM_COUNT; ++i) {
			// Don't read past the end.

			// Don't read past the end.
			if (startIndex + i >= alarms.length)
				break;

			GWTAlarm item = alarms[startIndex+i];
			// System.out.println(item.type);

			Button action = new Button("More");
			createPopup(action, i, item, "");

			Button defbut = new Button("Acknowledge");
			createPopup(defbut, i, item, ACTION);
			FlowPanel panel = new FlowPanel();
			Label label = new Label(item.source.trim());
			setDescription(label, item);
			panel.add(label);

			table.setWidget (i + 1, 0, panel);
			table.setText   (i + 1, 1, String.valueOf(item.sequenceNumber));
			table.setWidget (i + 1, 2, defbut);
			table.setWidget (i + 1, 3, action);			
		}
		
		// Clear any remaining slots.
		clear(i);
	}

	private void clear(int i){
		for (; i < VISIBLE_ALARM_COUNT; ++i) {
			//table.clearCell(i + 1, 4);
			table.setHTML(i + 1, 0, "");
			table.setHTML(i + 1, 1, "");
			table.setHTML(i + 1, 2, "");
			table.setHTML(i + 1, 3, "");
			
		}
	}
	
	
}
