package com.google.gwt.misge.alarms.client;
/*
 * @author jiorgos |  misge.intra@gmail.com under LGPL Licence and WITHOUT ANY WARRANTY
 */
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.ScrollPanel;
import com.google.gwt.user.client.ui.VerticalPanel;

/**
 * 
 * A composite for displaying the details of an alarm message.
 */
public class AlarmlDetail extends Composite {

  private VerticalPanel panel = new VerticalPanel();
  private VerticalPanel headerPanel = new VerticalPanel();
  private HTML subject = new HTML();
  private HTML sender = new HTML();
  private HTML alarmState = new HTML();
  private HTML alamrID = new HTML();
  private HTML body = new HTML();
  private ScrollPanel scroller = new ScrollPanel(body);

  public AlarmlDetail() {
    body.setWordWrap(true);

    headerPanel.add(subject);
    headerPanel.add(sender);
    headerPanel.add(alamrID);
    headerPanel.add(alarmState);
    headerPanel.setWidth("100%");

    DockPanel innerPanel = new DockPanel();
    innerPanel.add(headerPanel, DockPanel.NORTH);
    innerPanel.add(scroller, DockPanel.CENTER);

    innerPanel.setCellHeight(scroller, "100%");
    panel.add(innerPanel);
    innerPanel.setSize("100%", "100%");
    scroller.setSize("100%", "100%");
    initWidget(panel);

    setStyleName("mail-Detail");
    headerPanel.setStyleName("mail-DetailHeader");
    innerPanel.setStyleName("mail-DetailInner");
    subject.setStyleName("mail-DetailSubject");
    sender.setStyleName("mail-DetailSender");
    alamrID.setStyleName("mail-DetailRecipient");
    alarmState.setStyleName("mail-DetailRecipient");
    body.setStyleName("mail-DetailBody");
  }

  public void setItem(GWTAlarm item) {
    subject.setHTML(item.source);
    sender.setHTML("<b>Alarm type:</b>&nbsp;" + item.alarmType);
    alamrID.setHTML("<b>alamrID:</b>&nbsp;"+ item.alarmID);
    alarmState.setHTML("<b>alarm's state:</b>&nbsp;"+ item.alarmState);
    body.setHTML(item.msg);
  }

  public void deleteItem() {
	   this.setVisible(false);
	  }
  /**
   * Adjusts the widget's size such that it fits within the window's client
   * area.
   */
  public void adjustSize(int windowWidth, int windowHeight) {
    int scrollWidth = windowWidth - scroller.getAbsoluteLeft() - 9;
    if (scrollWidth < 1)
      scrollWidth = 1;

    int scrollHeight = windowHeight - scroller.getAbsoluteTop() - 9;
    if (scrollHeight < 1)
      scrollHeight = 1;

    scroller.setSize("" + scrollWidth, "" + scrollHeight);
  }
}
