package com.google.gwt.misge.alarms.client;
/*
 * @author jiorgos |  misge.intra@gmail.com under LGPL Licence and WITHOUT ANY WARRANTY
 */
import java.util.HashMap;

import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.user.client.Command;
import com.google.gwt.user.client.DeferredCommand;
import com.google.gwt.user.client.Timer;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.WindowResizeListener;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.ClickListener;
import com.google.gwt.user.client.ui.DockPanel;
import com.google.gwt.user.client.ui.FlowPanel;
import com.google.gwt.user.client.ui.Hyperlink;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.StackPanel;
import com.google.gwt.user.client.ui.VerticalPanel;
import com.google.gwt.user.client.ui.Widget;



public class AlarmsEntryPoint implements EntryPoint, WindowResizeListener {

  private static AlarmsEntryPoint singleton;
  private static HashMap registry = new HashMap();
  final AlarmServiceAsync alarmServiceaAsync = GwtAlarmItems.getInstance().getAsync();
  private static int oldAlarmCounter = 0;
  private static String categoryFlag = null;

  /**
   * Gets the singleton AlarmsEntryPoint instance.
   */
  
  public static AlarmsEntryPoint get() {
    
	  return singleton;
  }

  
  private VerticalPanel rightPanel = new VerticalPanel();
  private AlarmList AlarmList;
  private AlarmlDetail alamrDetaild = new AlarmlDetail();
  private Label status = new Label("total of:");
  /**
   * This method constructs the application user interface by instantiating
   * controls and hooking up event listeners.
   */
  public AlarmList getAlarmList(){
	  return AlarmList;
  }
  
  /* (non-Javadoc)
 * @see com.google.gwt.core.client.EntryPoint#onModuleLoad()
 */
public void onModuleLoad() {
    singleton = this;
    
    AlarmList = new AlarmList();
    rightPanel.add(AlarmList);
    rightPanel.add(alamrDetaild);
    AlarmList.setWidth("100%");
    alamrDetaild.setWidth("100%");

    DockPanel outer = new DockPanel();
      
    final StackPanel stackPanel = new StackPanel();
     
    stackPanel.add(makeButton("UNKNOWN",alarmServiceaAsync,AlarmList), createHeaderHTML("unknown.gif", "UNKNOWN"), true);
    stackPanel.add(makeButton("WARNING",alarmServiceaAsync,AlarmList), createHeaderHTML("warning.gif", "WARNING"), true);
    stackPanel.add(makeButton("INFO",alarmServiceaAsync,AlarmList), createHeaderHTML("info.gif", "INFO"), true);
    stackPanel.add(makeButton("CRITICAL",alarmServiceaAsync,AlarmList), createHeaderHTML("critical.gif", "CRITICAL"), true);
    stackPanel.add(makeButton("MAJOR",alarmServiceaAsync,AlarmList), createHeaderHTML("major.gif", "MAJOR"), true);
    
    
    FlowPanel flow = new FlowPanel();
    flow.add(stackPanel);
    
    
    DockPanel outerSouth = new DockPanel();
   
    outerSouth.add(new Image("home.gif"), DockPanel.WEST);
    outerSouth.add(status, DockPanel.WEST);
    Hyperlink  text = new Hyperlink ();
    text.setText("about");
    
     text.addClickListener(new ClickListener() {
            public void onClick(Widget sender) {
                  Window.alert("Jiorgos Miskakis misge.intra@gmail.com");
                }
     });
    
    VerticalPanel vertiCal = new VerticalPanel();
    vertiCal.add(outerSouth);
    vertiCal.add(text);
    
    flow.add(vertiCal);
    
    outer.add(flow, DockPanel.WEST);
    outer.add(rightPanel, DockPanel.CENTER);
    
    outer.setWidth("100%");
    outer.setSpacing(4);
    outer.setCellWidth(rightPanel, "100%");

    // Hook the window resize event, so that we can adjust the UI.
    Window.addWindowResizeListener(this);

    // Get rid of scrollbars, and clear out the window's built-in margin,
    // because we want to take advantage of the entire client area.
    Window.enableScrolling(false);
    Window.setMargin("0px");

    // Finally, add the outer panel to the RootPanel, so that it will be
    // displayed.
    RootPanel.get().add(outer);

    // Call the window resized handler to get the initial sizes setup. Doing
    // this in a deferred command causes it to occur after all widgets' sizes
    // have been computed by the browser.
    DeferredCommand.add(new Command() {
      public void execute() {
        onWindowResized(Window.getClientWidth(), Window.getClientHeight());
      }
    });
    
    Timer t = new Timer() {
        public void run() {
        	
        	alarmServiceaAsync.getAlarms(categoryFlag,new AsyncCallback() {
        		
                public void onFailure(Throwable caught) {
                	stackPanel.setTitle("Error"+oldAlarmCounter);
                }

                public void onSuccess(Object result) { 
                 	Integer current =  new Integer(((GWTAlarm[])result).length);
        	        if(oldAlarmCounter < current.intValue()){
        	        	int diff = current.intValue() - oldAlarmCounter;
        	        	if(((Button)registry.get(categoryFlag)).isVisible()){
        	        	    ((Button)registry.get(categoryFlag)).setText("New alarms: ("+diff +")");
        	        	}                	  
        	        }else{
                        ((Button)registry.get(categoryFlag)).setText("New alarms: ("+current.intValue() +")");
                    }
                	
                }
            });
            
        	alarmServiceaAsync.getLastAlarm(new AsyncCallback() {                
                public void onFailure(Throwable caught) {
                    stackPanel.setTitle("Error"+oldAlarmCounter);
                }
                public void onSuccess(Object result) {                    
                    status.setText(" Total of:"+((GWTAlarm)result).source + " alarms");
                }
            });

        }//run
      };//timer
      // Schedule the timer to run once in 15 seconds.
      t.scheduleRepeating(15000);
      
     
  }

  
private Button makeButton(final String title,final AlarmServiceAsync alrmService,final AlarmList alarmList){
      
	  final Button button = new Button(title);
	  button.addClickListener(new ClickListener() {
	        public void onClick(Widget sender) {
	        	alrmService.getAlarms(title,new AsyncCallback() {
                    public void onFailure(Throwable caught) {
                    	button.setText("failure:" +caught.getMessage());
                    }

                    public void onSuccess(Object result) {
                    	
                    	GWTAlarm async[] =  (GWTAlarm[]) result;
                    	button.setText("Alarms total = "+async.length);
                    	alarmList.update(async);
                    	categoryFlag = title;
                    	//client has received all the alarms
                    	oldAlarmCounter = async.length;                        
                    }
                });
                
                alrmService.getLastAlarm(new AsyncCallback() {
                    public void onFailure(Throwable caught) {
                        button.setText("failure:" +caught.getMessage());
                    }

                    public void onSuccess(Object result) {
                        status.setText(" Total of:"+((GWTAlarm)result).source + " alarms");                                            
                    }
                }); 
	            
            }
	    }); 
	    registry.put(title,button);
	    
        return button;
  }
  private String createHeaderHTML(String imageUrl, String caption) {
	    return "<table align='left'><tr>" + "<td><img src='" + imageUrl + "'></td>"
	      + "<td style='vertical-align:middle'><b style='white-space:nowrap'>"
	      + caption + "</b></td>" + "</tr></table>";
	  }
  
  public void onWindowResized(int width, int height) {
    alamrDetaild.adjustSize(width, height);
  }

  /**
   * Displays the specified item.
   * 
   * @param item
   */
  public void displayItem(GWTAlarm item) {
    alamrDetaild.setItem(item);
  }
}
